#include <gtk/gtk.h>
#include <stdio.h>
#include <string.h>

#include "config.h"

#include "engine.h"
#include "gui.h"

int main(int argc, char* argv[])
{
	int i;
	GError* perror = NULL;

	gtk_init(&argc, &argv);
	
	if (!initialize_engine(&perror))
	{
		printf(
			"Error initializing engine:\n%s\n",
			perror->message);

		g_error_free(perror);
		return 1;
	}
	
	initialize_gui();

	for (i = 0; i < argc; i++)
	{
		if (strcmp(argv[i], "-savegamedir") == 0)
		{
			if (i < argc - 1)
			{
				if (!load_savegame_directory(argv[i+1], &perror))
				{
					printf(
						"Error loading savegames from %s:\n%s\n",
						argv[i+1],
						perror->message);

					g_error_free(perror);

					return 1;
				}
			}
			else
			{
				printf("no directory specified for -savegamedir option\n");
				return 1;
			}
		}
	}

	gui_main();

	return 0;
}
