#ifndef __ENGINE_H__
#define __ENGINE_H__

#include <glib.h>
#include <gtk/gtk.h>

#define SHOW_ALL_PLAYERS -1

typedef struct
{
	gboolean draw_city_names;
	gboolean draw_city_growth;
	gboolean draw_city_production;
	
	int current_player;
} engine_settings;

GdkPixmap*	get_map(void);
void		get_settings(engine_settings* psettings);
int			get_turn_count(void);
gboolean	goto_turn(int turn, GError** pperror);
gboolean	initialize_engine(GError** pperror);
gboolean	is_game_loaded(void);
gboolean	load_savegame_directory(char* directoryname, GError** pperror);
void		set_settings(engine_settings* psettings);

#endif // __ENGINE_H__
