#include <stdio.h>

#include "config.h"

#include "ruleset_wrapper.h"

#include "game.h"

char* data_directory = "data";

struct flag_lookup_struct
{
	char*		identifier;
	char*		path;
	GdkPixbuf*	ppixbuf;
};

struct flag_lookup_struct flag_lookup_data[] =
{
	{ "f.afghanistan", "flags/afghanistan", NULL },
	{ "f.arab", "flags/arab", NULL },
	{ "f.argentina", "flags/argentina", NULL },
	{ "f.armenia", "flags/armenia", NULL },
	{ "f.assyria", "flags/assyria", NULL },
	{ "f.australia", "flags/australia", NULL },
	{ "f.austria", "flags/austria", NULL },
	{ "f.azerbaijan", "flags/azerbaijan", NULL },
	{ "f.barbarian", "flags/barbarian", NULL },
	{ "f.bavarian", "flags/bavarian", NULL },
	{ "f.belgium", "flags/belgium", NULL },
	{ "f.boer", "flags/boer", NULL },
	{ "f.bosnia", "flags/bosnia", NULL },
	{ "f.brasil", "flags/brasil", NULL },
	{ "f.bulgaria", "flags/bulgaria", NULL },
	{ "f.canada", "flags/canada", NULL },
	{ "f.catalan", "flags/catalan", NULL },
	{ "f.cheyenne", "flags/cheyenne", NULL },
	{ "f.chile", "flags/chile", NULL },
	{ "f.china", "flags/china", NULL },
	{ "f.columbia", "flags/columbia", NULL },
	{ "f.cornwall", "flags/cornwall", NULL },
	{ "f.croatia", "flags/croatia", NULL },
	{ "f.cuba", "flags/cuba", NULL },
	{ "f.czech", "flags/czech", NULL },
	{ "f.denmark", "flags/denmark", NULL },
	{ "f.dunedain", "flags/dunedain", NULL },
	{ "f.egypt", "flags/egypt", NULL },
	{ "f.elves", "flags/elves", NULL },
	{ "f.england", "flags/england", NULL },
	{ "f.estonia", "flags/estonia", NULL },
	{ "f.ethiopia", "flags/ethiopia", NULL },
	{ "f.europe", "flags/europe", NULL },
	{ "f.finland", "flags/finland", NULL },
	{ "f.france", "flags/france", NULL },
	{ "f.galicia", "flags/galicia", NULL },
	{ "f.germany", "flags/germany", NULL },
	{ "f.greece", "flags/greece", NULL },
	{ "f.greenland", "flags/greenland", NULL },
	{ "f.hobbits", "flags/hobbits", NULL },
	{ "f.holland", "flags/netherlands", NULL },
	{ "f.hungary", "flags/hungary", NULL },
	{ "f.iceland", "flags/iceland", NULL },
	{ "f.india", "flags/india", NULL },
	{ "f.indonesia", "flags/indonesia", NULL },
	{ "f.iran", "flags/iran", NULL },
	{ "f.iraq_old", "flags/iraq_old", NULL },
	{ "f.ireland", "flags/ireland", NULL },
	{ "f.israel", "flags/israel", NULL },
	{ "f.italy", "flags/italy", NULL },
	{ "f.japan", "flags/japan", NULL },
	{ "f.kampuchea", "flags/kampuchea", NULL },
	{ "f.kenya", "flags/kenya", NULL },
	{ "f.korea", "flags/korea", NULL },
	{ "f.krev", "flags/krev", NULL },
	{ "f.latvia", "flags/latvia", NULL },
	{ "f.lithuania", "flags/lithuania", NULL },
	{ "f.macedonia", "flags/macedonia", NULL },
	{ "f.malaysia", "flags/malaysia", NULL },
	{ "f.mars", "flags/mars", NULL },
	{ "f.mexico", "flags/mexico", NULL },
	{ "f.mongolia", "flags/mongolia", NULL },
	{ "f.mordor", "flags/mordor", NULL },
	{ "f.nato", "flags/nato", NULL },
	{ "f.netherlands", "flags/netherlands", NULL },
	{ "f.nigeria", "flags/nigeria", NULL },
	{ "f.norway", "flags/norway", NULL },
	{ "f.observer", "flags/observer", NULL },
	{ "f.pakistan", "flags/pakistan", NULL },
	{ "f.peru", "flags/peru", NULL },
	{ "f.philippines", "flags/philippines", NULL },
	{ "f.phoenicia", "flags/phoenicia", NULL },
	{ "f.poland", "flags/poland", NULL },
	{ "f.portugal", "flags/portugal", NULL },
	{ "f.quebec", "flags/quebec", NULL },
	{ "f.rome", "flags/rome", NULL },
	{ "f.russia", "flags/russia", NULL },
	{ "f.rwanda", "flags/rwanda", NULL },
	{ "f.scotland", "flags/scotland", NULL },
	{ "f.serbia", "flags/serbia", NULL },
	{ "f.silesia", "flags/silesia", NULL },
	{ "f.singapore", "flags/singapore", NULL },
	{ "f.slovenia", "flags/slovenia", NULL },
	{ "f.south_africa", "flags/south_africa", NULL },
	{ "f.soviet", "flags/soviet", NULL },
	{ "f.spain", "flags/spain", NULL },
	{ "f.sumeria", "flags/sumeria", NULL },
	{ "f.sweden", "flags/sweden", NULL },
	{ "f.switzerland", "flags/swiss", NULL },
	{ "f.syria", "flags/syria", NULL },
	{ "f.taiwan", "flags/taiwan", NULL },
	{ "f.thailand", "flags/thailand", NULL },
	{ "f.tunisia", "flags/tunisia", NULL },
	{ "f.turkey", "flags/turkey", NULL },
	{ "f.ukraine", "flags/ukraine", NULL },
	{ "f.united_kingdom", "flags/united_kingdom", NULL },
	{ "f.united_nations", "flags/united_nations", NULL },
	{ "f.unknown", "flags/unknown", NULL },
	{ "f.usa", "flags/usa", NULL },
	{ "f.vietnam", "flags/vietnam", NULL },
	{ "f.wales", "flags/wales", NULL },
	{ "f.alien", "flags/alien", NULL },
	{ NULL, NULL, NULL }
};

struct nation_type *get_nation_by_plrid(int id)
{
	struct player* pplayer = &game.players[id];
	
	return get_nation_by_plr(pplayer);
}

GdkPixbuf* get_nation_flag_pixbuf(struct nation_type* pnation)
{
	int current = 0;
	
	while (flag_lookup_data[current].identifier != NULL)
	{
		if (strcmp(flag_lookup_data[current].identifier,
				   pnation->flag_graphic_str) == 0)
		{
			if (flag_lookup_data[current].ppixbuf == NULL)
			{
				char buffer[1024];
				
				GError* error = NULL;
			
				sprintf(
					buffer,
					"%s/%s.png",
					data_directory,
					flag_lookup_data[current].path);

				flag_lookup_data[current].ppixbuf =
					gdk_pixbuf_new_from_file(buffer, &error);

				if (flag_lookup_data[current].ppixbuf == NULL)
				{
					g_print("Error loading %s\n", buffer);
					return FALSE;
				}
			}
			
			return flag_lookup_data[current].ppixbuf;
		}
		
		current++;
	}
	
	return NULL;
}

GdkPixbuf* get_player_flag_pixbuf(struct player* pplayer)
{
	return get_nation_flag_pixbuf(get_nation_by_plr(pplayer));
}
